----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:05:13 01/25/2013 
-- Design Name: 
-- Module Name:    attack - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_unsigned.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity attack is
    Port ( serial_in : in  STD_LOGIC;
           serial_to_gc : out  STD_LOGIC;
           clk : in  STD_LOGIC;
           cs : in  STD_LOGIC;
           trigger : out  STD_LOGIC);     --used for debugging (triggers scope)
end attack;

architecture Behavioral of attack is

signal byte_count: std_logic_vector(11 downto 0);
signal cmd_counter: std_logic_vector(5 downto 0);
signal bit_counter: std_logic_vector(2 downto 0);
signal serial_my : std_logic;
signal serial_my_enable: std_logic;

--binary image of NewLoader.s xor'ed with key
signal insert_string: std_logic_vector(0 to (32*24)-1) := 
(
x"38600000" & x"3c60d200" & x"3c800000" & x"38800035" &
x"3ca00000" & x"38a00880" & x"90620024" & x"90a20014" & 
x"4800002d" & x"3c600000" & x"90620024" & x"48000021" & 
x"38600100" & x"38800003" & x"38a00000" & x"3ca08100" & 
x"7ca803a6" & x"90a20018" & x"9062001c" & x"90820020" & 
x"80a20020" & x"54a007ff" & x"4082fff8" & x"4e800020"
)
xor
(
x"a5dfc82a" & x"4652f9c6" & x"e01e82fb" & x"59d08170" &
x"8b0ade70" & x"91c6ed94" & x"7d1bee1c" & x"5ff76492" &
x"849a482b" & x"b9474479" & x"0935f9b4" & x"6eb1c37e" &
x"e883b745" & x"d458ed16" & x"7a2d207c" & x"13d3950f" &
x"3ff1738e" & x"0bbe8666" & x"668e5c80" & x"6be6cc64" &
x"1fa837ee" & x"379c1c48" & x"bda18bb3" & x"87267650"
);

begin

	serial_to_gc <= ((serial_my and serial_my_enable) or (serial_in and not serial_my_enable))
		when (cs = '0') else 'Z';
				
	process (cs, clk)
		begin
		if (cs = '1') then
			cmd_counter <= (others => '0');
			bit_counter <= (0 => '1', others => '0');
			byte_count <= (others => '0');
			serial_my_enable <= '0';
			trigger <= '0';
		else
			if (clk'event and clk='1') then
			
			   --if the command bytes has been sent out and the first 32 bytes have been spent back. Deply the pay load 
			   if ((conv_integer(byte_count(11 downto 0)) > 31) and (conv_integer(byte_count(11 downto 0)) < 129)) then
					serial_my_enable <= '1';
					trigger <= '1';
				else
					serial_my_enable <= '0';
					trigger <= '0';
				end if;
			   
				--counter to keep track of how many bits of the command have been send to bios chip (command is 32 bits long)
				if (conv_integer(cmd_counter) < 32) then
					cmd_counter <= cmd_counter + '1';
				end if;
				
				serial_my <= insert_string((conv_integer((byte_count - 32) & bit_counter)));
				
				--every time bit_counter overflows one byte has been transmitted
				if (bit_counter = "111") then
					if (cmd_counter = 32) then
					   --if all the command bits have been sent out, keep trace of how many bytes have been sent back
						byte_count <= byte_count + '1';
					end if;
				end if;
				
				bit_counter <= bit_counter + '1';
			end if;
		end if;
   end process;
end Behavioral;

